// scaView.cpp : implementation of the CScaView class
//

#include "stdafx.h"
#include "sca.h"

#include "scaDoc.h"
#include "scaView.h"

#include "string.h"
#include "time.h"
#include "Model.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CEnvironment e;

/////////////////////////////////////////////////////////////////////////////
// CScaView

IMPLEMENT_DYNCREATE(CScaView, CFormView)

BEGIN_MESSAGE_MAP(CScaView, CFormView)
	//{{AFX_MSG_MAP(CScaView)
	ON_BN_CLICKED(IDC_Start, OnStart)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScaView construction/destruction

CScaView::CScaView()
	: CFormView(CScaView::IDD)
{
	//{{AFX_DATA_INIT(CScaView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	srand( (unsigned)time( NULL ) );


}

CScaView::~CScaView()
{
}

void CScaView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScaView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BOOL CScaView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CScaView printing

BOOL CScaView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CScaView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CScaView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CScaView::OnPrint(CDC* pDC, CPrintInfo*)
{
	// TODO: add code to print the controls
}

/////////////////////////////////////////////////////////////////////////////
// CScaView diagnostics

#ifdef _DEBUG
void CScaView::AssertValid() const
{
	CFormView::AssertValid();
}

void CScaView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CScaDoc* CScaView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CScaDoc)));
	return (CScaDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CScaView message handlers

void CScaView::OnStart() 
{
	  //6*4096*1000 =24576000
	  //test version
  


//	 GenerateNewAgent("v1.txt");
	AtTraining(200,0,(float)1);
//	 #pragma check_stack(off)
//	#pragma check_stack
    //Training(24576);

}

void CScaView::GenerateNewAgent(char* vdealer)
{
    CFile f,wf;
	char bigbuf[512],wbuf[512];

	
	//sample file
	f.Open("sample.txt",CFile::modeRead);
	CArchive ar(&f,CArchive::load,512,bigbuf);
    
	wf.Open(vdealer, CFile::modeCreate | CFile::modeWrite);
	CArchive war(&wf,CArchive::store,512,wbuf);
    
	char str[80];
	int i;
	char* tmp;

	//do nothing 
	for (i=0;i<5;i++)
	   {
		tmp=ar.ReadString(str,80);
        strcat(str,"\n");		
        war.WriteString(str);
	   }

	//update time line
	ar.ReadString(str,80);
    float v=((float) rand())/RAND_MAX;
	float damp=((float) rand())/RAND_MAX;
	float growth=((float) rand())/RAND_MAX;

	sprintf(str,"%.2f %.2f %.2f 0 0 0 0 0 0 0\n",v,damp,growth);
    war.WriteString(str);
    
	//update money line
    ar.ReadString(str,80);
    v=((float) rand())/RAND_MAX;
	damp=((float) rand())/RAND_MAX;
	growth=((float) rand())/RAND_MAX;

	sprintf(str,"%.2f %.2f %.2f 0 0 0 0 0 0 0\n",v,damp,growth);
    war.WriteString(str);

		//do nothing 
	for (i=0;i<27;i++)
	   {
		ar.ReadString(str,80);
		strcat(str,"\n");
        war.WriteString(str);
	   }
   
    ar.Close();
	war.Close();
    f.Close();
	wf.Close();
	//CFile::Remove("test1.txt");
	//CFile::Rename("test2.txt","test1.txt");
 

}

int CScaView::Judgement(int cond,int stay)
{
   if (cond>stay)
     return 1;
   else	
	 return 0;
}


void CScaView::CALearning(CCA* brain,int pf,float p)
{
	brain->InputX(brain->fn);
	brain->GeneS();  
    brain->GeneY();
	//complement everytime
    brain->UpdateRule(pf,p);
	brain->UpdateX();




}




void CScaView::AtTraining(unsigned long int trans,char* learner,float p)
{
  int j=0,count;
  int remain,done=0;
  int publish;
  int cond=6;

  static int vn=1;
  char vdealer[100];
  char al[100];  

  
  sprintf(vdealer,"vd%i.txt",vn);
  vn++;

  static ln=1;

  //no learner yet
  if (!learner)
   {
	  sprintf(al,"ln%i.txt",ln);
	  //create a learner data file
	  GenerateNewAgent(al);
	  learner=al;
      ln++;
   }

  //make a brain with learner
  CCA learnerCABrain(learner);

  unsigned long int i=0;

  while (i<trans)
    {
	  remain=0;
      publish=1;

      while ((remain<cond) && (publish==1))
	       {
			 GenerateNewAgent(vdealer);
	         e.InitEnvironment(learner,10,vdealer,15);
		     count = 0;

		     while(e.signal!=B_Leave && e.signal!=B_Deal) {
				e.UpdateAll();
//				if( count > 100 )
//					break;

				count++;
			 }

			 
	         if (e.signal==B_Deal && Judgement(cond,remain))
	           {
		         publish=0;
		       }

             remain++;
	         i++;
	       }

	  CALearning(&learnerCABrain,publish,p);
//CALearning(learnerCABrain,publish,p);
	  //including in CALearning
	  //UpdateAgent0(); 


    }

}













